package com.mangst.sat;

import java.util.Map;

/**
 * Represents a single solution to a SAT problem.
 */
public class Solution
{
  /**
   * Key = variable name<br>
   * Value = variable value
   */
  private Map<String, Boolean> values;

  public Solution( Map<String, Boolean> values )
  {
    this.values = values;
  }

  public boolean getValue( String variable )
  {
    return values.get( variable );
  }

  @Override
  public boolean equals( Object o )
  {
    if ( o == this )
    {
      return true;
    }
    if ( !( o instanceof Solution ) )
    {
      return false;
    }

    Solution s = ( Solution ) o;
    return values.equals( s.values );
  }

  @Override
  public int hashCode()
  {
    return values.hashCode();
  }

  @Override
  public String toString()
  {
    return values.toString();
  }
}
